//SchriftenTausch_Datei_205d.js
// 17.11.14 / Hans Hsler, Chtelard 52, CH-1018 Lausanne / E-mail: hsa@ringier.ch
//DESCRIPTION:Austauschen von Schriften.

// das Anzeigen der Dialoge aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Version des Programms prfen
var appVers = app.version[0];
if (appVers != 4) {
	alert ("Dieses Script nur mit InDesign CS2 benutzen.", "Stop");
	exit();
}

var oneDoc = true;
var selFolder = Folder ("Tiger/Users/Documents/");

// prfen, ob ein Dokument offen ist
if (app.documents.length == 0) {
	oneDoc = false;
	// den Dialog zur Ordnerauswahl anzeigen 
	var sourceFolder = Folder.selectDialog("Den Ordner whlen, welcher die InDesign-Dateien enthlt", selFolder);
	if (sourceFolder != null) {
		// versuchen, die Textdatei zu finden
		var fileList = Folder(sourceFolder).getFiles("*.txt");
		if (fileList.length == 0) {
			alert ("Der Ordner enthlt keine Textdatei.", "Problem");
			exit();
		}
		var f = fileList[0];
	}
	else {
		exit();
	}
}
else {
	// den Benutzer bitten, eine Textdatei zu whlen
	var f = File(selFolder).openDlg("Die Datei mit den Schriftnamen whlen", "Text Files:*.txt");
	if (f == null) {
		exit();
	}
}

// versuchen, die Datei zu lesen
var fontsString = "";
var fileIsOpen = f.open("r");
if (fileIsOpen) {
	try {
		fontsString = f.read();
		f.close();
	}
	catch (e) {
		try {
			f.close();
		}
		catch (e) {
		}
	}
}

// die Separator-Zeichen testen
var nameSep = "";
var paraSep = "";
var pairSep = "";
if (fontsString.indexOf("\t") != -1) {
	nameSep = "tab";
}
if (fontsString.indexOf("\r\n") != -1) {
	paraSep = "\r\n";
}
else if (fontsString.indexOf("\r") != -1) {
	paraSep = "\r";
}
else if (fontsString.indexOf("\n") != -1) {
	paraSep = "\n";
}
if (fontsString.indexOf("=") != -1) {
	pairSep = "=";
}
if (nameSep == "") {
	alert ("Die gewhlte Datei enthlt keine Tabs\n(zwischen Schriftfamilie und Stil).", "Stop");
	exit();
}
if (pairSep == "") {
	alert ("Die gewhlte Datei enthlt keine Gleichheitszeichen\n(zwischen alten und neuen Namen).", "Stop");
	exit();
}
if (paraSep == "") {
	alert ("Die gewhlte Datei enthlt\nkeine Return-Zeichen.", "Stop");
	exit();
}

// die Textkette der Schriftnamen in eine Liste verwandeln
try {
	fontsList = fontsString.split(paraSep);
}
catch (e) {
}

// wenn ein Dokument offen ist, die Funktion aufrufen
var probCtr = 0;
if (oneDoc) {
	replaceFonts();
}
// sonst die InDesign-Dokumente auflisten und sie der Reihe nach behandeln
else {
	var docList = Folder(sourceFolder).getFiles("*.indd");
	var nDocs = docList.length;
	if (nDocs == 0) {
		alert ("Der gewhlte Ordner enthlt keine InDesign-Dokumente.", "Achtung");
		exit();
	}
	// die Anzeige von Dialogen ausschalten (falls Schriften oder Bilder fehlen)
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
	var docVers;
	for (var d=0; d<nDocs; d++) {
		docVers = testVers(docList, d);
		if (docVers > 0 && docVers <= appVers) {
			try {
				app.open(File(docList[d]));
				replaceFonts();
				try {
					app.activeDocument.save();
				}
				catch (e) {
				}
				app.activeDocument.close();
			}
			catch (e) {
				probCtr++;
			}
		}
		else {
			probCtr++;
		}
	}
}

// das Anzeigen der Dialoge aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// das Ende der Aktion verknden
if (probCtr == 0) {
	alert ("Fertig.", " ");
}
else if (probCtr == 1) {
	alert ("Ein Dokument konnte nicht behandelt werden.", "Achtung");
}
else {
	alert ("Nichtbehandelte Dokumente: " + probCtr, "Achtung");
}


///////////////////////////////////////////////////////////////////////////////
// die beiden Funktionen
///////////////////////////////////////////////////////////////////////////////

function testVers(docList, d) {
	// versuchen, die InDesign-Datei zu lesen
	var t = docList[d];
	var testString = "";
	var fileIsOpen = t.open("r");
	if (fileIsOpen) {
		try {
			testString = t.read(40);
			t.close();
		}
		catch (e) {
			try {
				t.close();
			}
			catch (e) {
			}
		}
	}
	if (testString !="") {
		try {
			var pfID = testString.charCodeAt(24);
			if (pfID == 2) { // = Mac
				return testString.charCodeAt(32);
			}
			else if (pfID == 1) {  // = Win
				return testString.charCodeAt(29);
			}
			else {
				var docVers = 0;
			}
		}
		catch (e) {
			return 0;
		}
	}
	else {
		return 0;
	}
}


///////////////////////////////////////////////////////////////////////////////
// Die Schriften der Texte und Formate austauschen
///////////////////////////////////////////////////////////////////////////////

function replaceFonts() {
	// eine Referenz zum obersten Dokument
	var curDoc = app.documents[0];
	
	// den Nullpunkt auf Null/Null setzen
	curDoc.zeroPoint = [0,0];
	
	// den Ursprung der Linealeinheiten auf "Seite" setzen
	rO = curDoc.viewPreferences.rulerOrigin;
	if (rO != 1380143215) {
		curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
	}
	
	// die Grsse der ersten Seite feststellen
	var pSz = curDoc.pages[0].bounds;
	
	// die Vorgaben-Einstellungen der Formate festlegen
	// Absatzformat = "[Einfacher Absatz] / Zeichenformat = "[Kein Stil]"
	try {
		var eaParaStyle = curDoc.paragraphStyles.item(1);
		var noCharStyle = curDoc.characterStyles.item(0);
		curDoc.textDefaults.appliedParagraphStyle = eaParaStyle;
		curDoc.textDefaults.appliedCharacterStyle = noCharStyle;
	}
	catch (e) {
	}
	
	// eine Referenz zum Farbfeld "Papier" definieren
	var whiteColor = curDoc.swatches.item("Paper");
	
	// testen, ob die aktive Ebene gesperrt ist
	var curLayer = app.activeWindow.activeLayer;
	var layerLocked = curLayer.locked;
	if (layerLocked) {
		curLayer.locked = false;
	}
	
	// den Absatz-Format-Rahmen lschen (falls dieser vorhanden ist)
	try {
		curDoc.textFrames.item("paraStyles").remove();
	}
	catch (e) {
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// die Schriften der Texte austauschen
	var allStories = curDoc.stories;
	var curFont;
	var curNew;
	var curOld;
	var curPair;
	var nFonts = fontsList.length;
	var nStories = allStories.length;
	var nTsr;
	var tsr;
	var tsrFonts;
	
	for (var i=0; i<nStories; i++) {
		tsr = allStories[i].textStyleRanges;
		nTsr = tsr.length;
		tsrFonts = tsr.everyItem().appliedFont;
		for (var j=nTsr-1; j>-1; j--) {
			try {
				curFont = tsrFonts[j].name;
				for (var k=0; k<nFonts; k++) {
					curPair = fontsList[k];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						curNew = curPair.split("=")[1];
						if (curNew != "") {
							try {
								tsr[j].appliedFont = curNew;
							}
							catch (e) {
							}
							break;
						}
					}
				}
			}
			catch (e) {
			}
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// die Schriften der Absatzformate austauschen
	
	// einen Textrahmen erzeugen, benennen und die Hintergrundfarbe zuweisen
	var paraFrame = app.activeWindow.activePage.textFrames.add({geometricBounds:[pSz[0],pSz[1],pSz[2],pSz[3]], 
		label:"paraStyles", fillColor:whiteColor});
	var firstPara = paraFrame.parentStory.contents = curDoc.paragraphStyles[1].name + "\r";
	firstPara.appliedParagraphStyle = curDoc.paragraphStyles[1];
	
	// die Liste der Absatzformate erstellen
	var allParaStyles = curDoc.paragraphStyles;
	var paraCount = allParaStyles.length;
	
	var paraStory = paraFrame.parentStory;
	var paraStyle;
	// eine Schleife durch die Liste. Der Zhler beginnt bei "2" (statt bei "0"), 
	// damit "[Kein Absatzformat]" ausgeklammert wird (nicht per Script editierbar) 
	// und "[Einfacher Absatz]" ist schon erledigt
	// aber die Abstze mssen mit '(i-1)' adressiert werden
	for (var i=2; i<paraCount; i++) {
		paraStyle = allParaStyles[i].name;
		// den aktuellen Namen einsetzen
		paraStory.insertionPoints[-1].contents = paraStyle + "\r";
		try {
			// der aktuellen Zeile das entsprechende Absatzformat zuweisen
			paraStory.paragraphs[(i-1)].appliedParagraphStyle = paraStyle;
		}
		catch (e) {
		}
	}	
	
	// den Inhalt des Rahmens, welcher die Namen der Absatzformate enthlt, 
	// in die Variable 'paraStory' geben und diese Textkette in eine Liste verwandeln
	try {
		var paraStory = curDoc.textFrames.item("paraStyles").parentStory;
		var paraString = paraStory.contents;
		var paraList = paraString.split("\r");
		var nParas = paraList.length;
	}
	catch (e) {
		alert ("Der Rahmen mit den Formatmustern\nist unauffindbar.", "Stop");
		app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
		exit();
	}
	
	var ctr = 0;
	var curStyle;
	
	// eine Schleife durch die Liste
	for (var i=0; i<nParas-1; i++) {
		curStyle = curDoc.paragraphStyles.item(paraList[i]);
		try {
			curFont = paraStory.paragraphs[i].characters[2].appliedFont.name;
			for (var j=0; j<nFonts; j++) {
				curPair = fontsList[j];
				curOld = curPair.split("=")[0];
				if (curFont == curOld) {
					curNew = curPair.split("=")[1];
					if (curNew != "") {
						try {
							curStyle.appliedFont = curNew;
						}
						catch (e) {
						}
					}
					break;
				}
			}
		}
		catch (e) {
		}
	}
	
	
	/////////////////////////////////////////////////////////////////////////////
	// die Schriften der Zeichenformate austauschen
	var charStyles = curDoc.characterStyles;
	var curF;
	var curS;
	var nCharStyles = charStyles.length;
	
	for (var i=1; i<nCharStyles; i++) {
		try {
			curStyle = charStyles[i];
			curF = curStyle.appliedFont;
			curS = curStyle.fontStyle;
			if (curS != 1851876449) {
				curFont = curF + "\t" + curS;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					if (curFont == curOld) {
						try {
							curNew = curPair.split("=")[1];
							if (curNew != "") {
								curStyle.appliedFont = curNew;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
			else {
				curFont = curF;
				for (var j=0; j<nFonts; j++) {
					curPair = fontsList[j];
					curOld = curPair.split("=")[0];
					curFam = curOld.split("\t")[0];
					if (curFont == curFam) {
						try {
							curNew = curPair.split("=")[1];
							newFam = curNew.split("\t")[0];
							if (curNew != "") {
								curStyle.appliedFont = newFam;
							}
						}
						catch (e) {
						}
						break;
					}
				}
			}
		}
		catch (e) {
		}
	}
	
	/////////////////////////////////////////////////////////////////////////////
	// Aufrumen
	/////////////////////////////////////////////////////////////////////////////
	
	// den Absatz-Format-Rahmen entfernen
	try {
		curDoc.textFrames.item("paraStyles").remove();
	}
	catch (e) {
	}
	
	// den Ursprung der Linealeinheiten zurcksetzen
	if (rO != 1380143215) {
		try {
			curDoc.viewPreferences.rulerOrigin = rO;
		}
		catch (e) {
		}
	}
	
	// eine eventuelle Sperrung der Ebene wiederherstellen
	if (layerLocked) {
		curLayer.locked = true;
	}
}